Index: /XIOS/trunk/src/filter/ternary_arithmetic_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/ternary_arithmetic_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/ternary_arithmetic_filter.cpp	(revision 1704)
@@ -1,3 +1,6 @@
 #include "ternary_arithmetic_filter.hpp"
+#include "workflow_graph.hpp"
+#include "yacc_var.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -8,5 +11,66 @@
     , value1(value1)
     , value2(value2)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CScalarScalarFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+    bool firstround;
+
+    if(building_graph)
+    {
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      // not first round
+      else 
+      {
+        firstround=false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CScalarScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -16,4 +80,12 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
 
     if (packet->status == CDataPacket::NO_ERROR)
@@ -28,5 +100,66 @@
     , value1(value1)
     , value2(value2)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CScalarFieldScalarArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+    bool firstround;
+
+    if(building_graph)
+    {
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      // not first round
+      else 
+      {
+        firstround=false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CScalarFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -36,4 +169,12 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
 
     if (packet->status == CDataPacket::NO_ERROR)
@@ -47,5 +188,81 @@
     , op(operatorExpr.getOpScalarFieldField(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CScalarFieldFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+
+    bool firstround;
+
+    if(building_graph)
+    {  
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+    
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+    
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+        }
+        CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+ 
+      }
+      // not first round
+      else 
+      {
+        firstround = false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[1]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[1]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CScalarFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -55,4 +272,12 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
 
     if (data[0]->status != CDataPacket::NO_ERROR)
@@ -75,5 +300,66 @@
     , value1(value1)
     , value2(value2)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CFieldScalarScalarArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+    bool firstround;
+
+    if(building_graph)
+    {
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      // not first round
+      else 
+      {
+        firstround=false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CFieldScalarScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -84,4 +370,12 @@
     packet->status = data[0]->status;
 
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
+
     if (packet->status == CDataPacket::NO_ERROR)
       packet->data.reference(op(data[0]->data, value1, value2));
@@ -95,5 +389,81 @@
     , op(operatorExpr.getOpFieldScalarField(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CFieldScalarFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+
+    bool firstround;
+
+    if(building_graph)
+    {  
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+    
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+    
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+        }
+        CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+ 
+      }
+      // not first round
+      else 
+      {
+        firstround = false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[1]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[1]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CFieldScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -103,4 +473,12 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
 
     if (data[0]->status != CDataPacket::NO_ERROR)
@@ -120,5 +498,82 @@
     , op(operatorExpr.getOpFieldFieldScalar(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    std::cout<<"expression = "<<expression;
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CFieldFieldScalarArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+
+    bool firstround;
+
+    if(building_graph)
+    {  
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+    
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+    
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+        }
+        CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+ 
+      }
+      // not first round
+      else 
+      {
+        firstround = false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[1]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[1]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CFieldFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -128,4 +583,12 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
 
     if (data[0]->status != CDataPacket::NO_ERROR)
@@ -145,5 +608,94 @@
     : CFilter(gc, 3, this)
     , op(operatorExpr.getOpFieldFieldField(op))
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+    /* Nothing to do */ 
+  };
+
+  std::tuple<int, int, int> CFieldFieldFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    int unique_filter_id;
+
+    bool firstround;
+
+    if(building_graph)
+    {  
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+    
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+    
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[2]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[2]->src_filterID].filter_filled = 0 ;
+        }
+        CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+ 
+      }
+      // not first round
+      else 
+      {
+        firstround = false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[1]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[1]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[2]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[2]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[2]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CFieldFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -153,4 +705,12 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
+    
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
 
     if (data[0]->status != CDataPacket::NO_ERROR)
Index: /XIOS/trunk/src/filter/ternary_arithmetic_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/ternary_arithmetic_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/ternary_arithmetic_filter.hpp	(revision 1704)
@@ -5,4 +5,5 @@
 #include <string>
 #include "operator_expr.hpp"
+#include <tuple>
 
 namespace xios
@@ -36,4 +37,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CScalarScalarFieldArithmeticFilter
 
@@ -67,4 +69,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CScalarScalarFieldArithmeticFilter
 
@@ -95,4 +98,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CScalarScalarFieldArithmeticFilter
 
@@ -127,4 +131,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldScalarScalarArithmeticFilter
 
@@ -156,4 +161,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldScalarFieldArithmeticFilter
 
@@ -185,4 +191,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldFielScalardArithmeticFilter
 
@@ -212,4 +219,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldFielFieldArithmeticFilter
 
